const EXPORTED_SYMBOLS = ['popupCore'];

Components.utils.import("resource://migre-me-hultmann-modules/util.js");
//util.log('import app.js');


function popupCore(popup, tid, doc) {
  var inputNode = doc.popupNode;
  if (isAllowedNode(inputNode) === false) {
    return;
  }

  if (isAllowedMenu(popup) === false) {
    return;
  }


  var addr = extractWord(doc);
  if (addr === null) {
    return;
  }


  var uri = toUri(addr);
  if (uri === null) {
    return;
  }

  // show commands
  popup.addEventListener('popuphidden', onPopupHidden, false);

  var cmdData = {
    uri: uri,
    typed: addr,
    node: inputNode,
    selectionStart: inputNode.selectionStart,
    selectionEnd: inputNode.selectionEnd
  };

  menuPopup.populate(popup, cmdData, tid === 'urlbar');
}


function onPopupHidden(evt) {
  var doc = evt.originalTarget.ownerDocument;
  //util.log('popuphidden '+evt.originalTarget.tagName+', '+evt.originalTarget.id);

  evt.originalTarget.removeEventListener('popuphidden', onPopupHidden, false);
  var el = doc.getElementById('migre-me-cmd');
  if (el) {
    //util.log(document.defaultView.getComputedStyle(el, '').getPropertyValue("width"));
    el.parentNode.removeChild(el);
    var el2 = doc.getElementById('migre-me-sep');
    el2.parentNode.removeChild(el2);
  }
}


function extractWord(doc) {
  var inputNode = doc.popupNode;
  var txtNode;
  var isSelection = inputNode.selectionStart !== inputNode.selectionEnd;
  if (isSelection) {
    txtNode = inputNode.value.substring(inputNode.selectionStart, inputNode.selectionEnd);
    if (txtNode.indexOf('\n') > - 1) {
      return null;
    }
    if (txtNode !== util.trim(txtNode)) {
      return null;
    }
    return txtNode;
  }


  var addr;
  // if empty=NaN; empty input|empty region textatra=node.data=undefined;
  var pos = doc.popupRangeOffset;
  txtNode = isNaN(pos) || doc.popupRangeParent === null ? undefined : doc.popupRangeParent.data;
  if (txtNode === undefined) {
    util.log('no txt,' + doc.popupRangeParent + pos);
    return null;
  }

  var wordIdx = util.findCurrentUrlPos(txtNode, pos);
  return txtNode.substr(wordIdx[0], wordIdx[1]);
}


function isAllowedNode(inputNode) {
  if (!inputNode) {
    return false;
  }
  //document.designMode === 'on'
  switch (inputNode.tagName) {
    case 'INPUT':
    case 'html:input':
      return inputNode.type === 'text';
    case 'TEXTAREA':
    case 'html:textarea':
      return true;
    default:
      return false;
  }
}


function isAllowedMenu(menu) {
  var items = menu.getElementsByTagNameNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul', 'menuitem');
  var ok = false;
  for (var idx = 0; idx < items.length; idx++) {
    var item = items[idx];

    var id = '';
    if (item.hasAttribute('command')) {
      id = item.getAttribute('command');
    } else if (item.hasAttribute('cmd')) {
      id = item.getAttribute('cmd');
    } else {
      continue;
    }

    if (id === 'cmd_find') {
      return false;
    }
    if (id === 'cmd_cut') {
      ok = true;
    }
  }
  return ok;
}


function toUri(txt) {
  var uri = null;
  if (txt.indexOf('www.') === 0) {
    uri = util.stringToUri('http://' + txt);
  } else {
    uri = util.stringToUri(txt);
  }

  if (uri === null) {
    return null;
  }

  switch (uri.scheme) {
    case 'http':
    case 'https':
    case 'ftp':
    case 'gopher':
      return uri;
    default:
      return null;
  }
}


const menuPopup = {
  populate: function(popupNode, cmdData, isUrlbar) {
    var doc = popupNode.ownerDocument;
    var sepItem = doc.getElementById('migre-me-sep');
    var menuItem = doc.getElementById('migre-me-cmd');
    if (sepItem) {
      doc.defaultView.alert('migre.me ext BUG ' + sepItem + menuItem);
    } else {
      sepItem = popupNode.insertBefore(doc.createElement('menuseparator'), popupNode.firstChild)
      menuItem = popupNode.insertBefore(doc.createElement('menuitem'), popupNode.firstChild)
    }


    //menuItem.style.width='40em';//436px
    //menuItem.style.width='30em';//326px
    //menuItem.style.width='28em';
    /*
    util.log(doc.defaultView.getComputedStyle(menuItem, '').getPropertyValue("width"));
    util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').getPropertyValue("width"));
    util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').getPropertyCSSValue("width").cssText);
    util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').width);
    */


    //menuItem.setAttribute('crop', 'center');
    var menuUrl = cmdData.uri.spec.replace(/^https?:\/\//i, '');
    if (menuUrl.length > 23) {
      menuUrl = menuUrl.substr(0, 23) + String.fromCharCode(0x2026);//'…';
    }


    if (isUrlbar || cmdData.node.readOnly) {
      if (cmdData.uri.host === 'migre.me') {
        menuItem.setAttribute('label', util.getText('context.copyUncompressed.label', [menuUrl]));
        menuItem.setAttribute('accesskey', util.getText('context.copyUncompressed.accesskey', []));
      } else {
        menuItem.setAttribute('label', util.getText('context.copyCompressed.label', [menuUrl]));
        menuItem.setAttribute('accesskey', util.getText('context.copyCompressed.accesskey', []));
      }
      this._cmdcopy(menuItem, cmdData.uri);

    } else {
      if (cmdData.uri.host === 'migre.me') {
        menuItem.setAttribute('label', util.getText('context.replaceUncompressed.label', [menuUrl]));
        menuItem.setAttribute('accesskey', util.getText('context.replaceUncompressed.accesskey', []));
      } else {
        menuItem.setAttribute('label', util.getText('context.replaceCompressed.label', [menuUrl]));
        menuItem.setAttribute('accesskey', util.getText('context.replaceCompressed.accesskey', []));
      }
      this._cmdreplace(menuItem, cmdData);
    }

    menuItem.setAttribute('tooltiptext', cmdData.uri.spec);

    var isOffline = Components
                      .classes['@mozilla.org/network/io-service;1']
                      .getService(Components.interfaces.nsIIOService2)
                      .offline;
    menuItem.setAttribute('disabled', isOffline);
    menuItem.setAttribute('id','migre-me-cmd');
    sepItem.setAttribute('id','migre-me-sep');
  },


  _cmdcopy: function(menuItem, oldUri) {
    var oncopy = function(evt) {
      Components.utils.import("resource://migre-me-hultmann-modules/run.js");
      var originBrowser = menuItem.ownerDocument.defaultView.gBrowser.selectedBrowser;
      var asyncRequest = getRequest(originBrowser);
      asyncRequest.onSuccess = function(newUrl) {
        Components
          .classes['@mozilla.org/widget/clipboardhelper;1']
          .getService(Components.interfaces.nsIClipboardHelper)
          .copyString(newUrl);
      };
      if (oldUri.host === 'migre.me') {
        asyncRequest.restore(oldUri);
      } else {
        asyncRequest.convert(oldUri);
      }
    };
    menuItem.addEventListener('command', oncopy, false);
  },


  _cmdreplace: function(menuItem, cmdData) {
    var onreplace = function(evt) {
      var chromeWnd = menuItem.ownerDocument.defaultView;
      var browser = chromeWnd.gBrowser.selectedBrowser;//originBrowser

      Components.utils.import("resource://migre-me-hultmann-modules/run.js");

      var asyncRequest = getRequest(browser); //chromeWnd);
      asyncRequest.onSuccess = function(newUrl) {
        replaceCore(cmdData, newUrl, browser);
      };

      if (cmdData.uri.host === 'migre.me') {
        asyncRequest.restore(cmdData.uri);
      } else {
        asyncRequest.convert(cmdData.uri);
      }
    }
    menuItem.addEventListener('command', onreplace, false);
  }

};
