const EXPORTED_SYMBOLS = ['getRequest', 'replaceCore'];

Components.utils.import("resource://migre-me-hultmann-modules/util.js");

function getRequest(browserOrigin) {
  var req = new AsyncRequest();
  var started;

  req.onStart = function() {
    var chromeWnd = browserOrigin.ownerDocument.defaultView;
    chromeWnd.setCursor('progress');
    started = new Date().getTime();
    /*
    var e = chromeWnd.document.documentElement;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';

    //chromeWnd.chromeWnd.gBrowser.selectedBrowser.defaultView.setCursor('progress');

    e = chromeWnd.gBrowser.selectedBrowser.contentDocument.body;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';
    */
  };

  req.onStop = function() {
    var span = new Date().getTime() - started;
    util.log('migre.me connection: '+span+'ms');
    /*
    var e = chromeWnd.document.documentElement;
    util.log('onstop ['+e.className+']');
    var t = e.className.split(/\s+/).map(function(i) {
      return i == 'migreme-hltmnn-progress' ? '' : i;
    });
    e.className = t.join(' ');
    */
    //util.log('cursor auto');
    var chromeWnd = browserOrigin.ownerDocument.defaultView;
    chromeWnd.setCursor('auto');
  };

  req.onError = function(errData) {
    var buildLog = function() {
      var x = errData.xhr;
      return 'GET ' + req.requestUrl + '\n====================8<-----------------\n' +
             x.status + ' ' + x.statusText + '\n' +
             x.getAllResponseHeaders() + '\n' +
             x.responseText;
    }


    var label = util.getText('notification.response.label', []);
    var box = util2.initNotification(browserOrigin);

    switch (errData.id) {
      case 0:
        showNotification(box, util.getText('notification.connection.label', []), null, null);
        break;
      case 1:
        showNotification(box, label, util.getText('error.response.details.status', []), buildLog());
        break;
      case 2:
        showNotification(box, label, util.getText('error.response.details.generic', []), buildLog());
        break;
      case 3:
        showNotification(box, label, util.getText('error.response.details.xml', []), buildLog());
        break;
      case 4:
        showNotification(box, label, util.getText('error.response.details.nodata', []), buildLog());
        break;
      case 5:
        showNotification(box, util.getText('notification.request.compress.label', [errData.msg]), null, null);
        break;
      case 6:
        showNotification(box, util.getText('notification.request.uncompress.label', [errData.msg]), null, null);
        break;
      default:
        throw 'bug';
    }
  }

  return req;
}



function replaceCore(cmdData, newUrl, browser) {
  var rv;
  if (cmdData.selectionStart !== cmdData.selectionEnd) {
    //selection
    var txt = cmdData.node.value;
    rv = {
      count: 1,
      text: txt.substr(0, cmdData.selectionStart) + newUrl + txt.substr(cmdData.selectionEnd),
      caretStart: cmdData.selectionStart,
      caretEnd: cmdData.selectionStart + newUrl.length
    };
  } else {
    rv = replaceAll(cmdData, newUrl);
  }


  var invalid = false;
  if (rv.count > 0) {
    var pos = 'rows' in cmdData.node ? cmdData.node.scrollTop : -1;
    cmdData.node.value = rv.text;
    // restore scrollbar position
    if (pos > -1) {
      cmdData.node.scrollTop = pos;
    }
    try {
      // node/page is no longer available
      cmdData.node.setSelectionRange(rv.caretStart, rv.caretEnd);
    } catch(ex) {
      invalid = true;
    }
  } else {
    invalid = true;
  }

  if (invalid) {
    // matched text/node/tab not found
    var box = util2.initNotification(browser);
    util2.showNotFoundNotification(box, newUrl);
  }
}



function showNotification(box, msg, error, txtLog) {
  var chromeWnd = box.ownerDocument.defaultView;

  var buttonConfig = null;
  if (error !== null) {
    buttonConfig = [{
      callback: function(evt) {
        var params = {
          title: util.getText('error.response.details.title', []),
          close: util.getText('error.response.details.close.label', []),
          label: error,
          description: txtLog
        };
        chromeWnd.openDialog('chrome://migre-me-hultmann/content/warning.xul',
                          '',
                          'chrome,centerscreen,modal',
                          params);
        return true;
      },
      label: util.getText('notification.button.label', []),
      accessKey: util.getText('notification.button.accesskey', [])
    }];
  }

  var box = chromeWnd.gBrowser.getNotificationBox(chromeWnd.gBrowser.selectedBrowser);
  var notif = box.appendNotification(
                  msg,
                  'migre-me-hultmann-warning',
                  'chrome://browser/skin/Info.png',
                  box.PRIORITY_WARNING_MEDIUM,
                  buttonConfig);
}

const util2 = {

  initNotification: function(browserOrigin) {
    var tabBrowser = browserOrigin.ownerDocument.defaultView.gBrowser;
    var sel = this.findTabByBrowser(browserOrigin, tabBrowser);
    if (sel !== null) {
      tabBrowser.selectedTab = sel;
    } else {
      tabBrowser = Components
        .classes['@mozilla.org/appshell/window-mediator;1']
        .getService(Components.interfaces.nsIWindowMediator)
        .getMostRecentWindow('navigator:browser')
        .gBrowser;
      browserOrigin = tabBrowser.selectedBrowser;
    }
    return tabBrowser.getNotificationBox(browserOrigin);
  },

  findTabByBrowser: function(browser, tabBrowser) {
      const nodes = tabBrowser.mTabContainer.childNodes;
      for (var idx = 0, len = nodes.length; idx < len; idx++) {
          if (nodes[idx].linkedBrowser === browser) {
              return nodes[idx];
          }
      }
      return null;
  },

  showNotFoundNotification: function(box, newUrl) {
    var buttonConfig = [{
      callback: function(evt) {
        Components
          .classes['@mozilla.org/widget/clipboardhelper;1']
          .getService(Components.interfaces.nsIClipboardHelper)
          .copyString(newUrl);
        return false;
      },
      label: util.getText('notification.node.notfound.button.label', []),
      accessKey: util.getText('notification.node.notfound.button.accesskey', [])
    }];

    var notif = box.appendNotification(
                    util.getText('notification.node.notfound.label', [newUrl]),
                    'migre-me-hultmann-warning',
                    'chrome://browser/skin/Info.png',
                    box.PRIORITY_WARNING_MEDIUM,
                    buttonConfig);
  }
};




function replaceAll(cmdData, newUrl) {
  var inp = cmdData.node;
  var txt = inp.value;
  var qty = 0;
  var idxStart = 0;

  do {
    var idxUrl = txt.indexOf(cmdData.typed, idxStart);
    if (idxUrl > -1) {
      var wordIdx = util.findCurrentUrlPos(txt, idxUrl);
      var urlFound = txt.substr(wordIdx[0], wordIdx[1]);
      //util.log('found ['+wordIdx[0]+', '+wordIdx[1]+' '+urlFound+']');
      if (urlFound === cmdData.typed) {
        txt = txt.substr(0, wordIdx[0]) + newUrl + txt.substr(wordIdx[0] + wordIdx[1]);
        idxStart = wordIdx[0] + newUrl.length;
        qty++;
      } else {
        //util.log('NOT replaced\n'+urlFound +' != '+ cmdData.typed);
        idxStart = wordIdx[0] + wordIdx[1];
      }
    }
  } while (idxUrl > -1);


  return {
    count: qty,
    text: txt,
    caretStart: idxStart,
    caretEnd: idxStart
  };
}





function AsyncRequest() {
  this.requestUrl = null;
  this.onError = null;
  this.onSuccess = null;
  this.onStart = null;
  this.onStop = null;
}

AsyncRequest.prototype.convert = function(uri) {
  //this.requestUrl = "http://localhost:81/migre.me/api-test.html?url="+ encodeURIComponent(uri.spec);
  this.requestUrl = "http://migre.me/api.xml?url="+ encodeURIComponent(uri.spec);

  var xhr = this._createXhr();
  var me = this;
  xhr.onload = function(evt) {
    me.requestSuccess(this); // this == evt.target == evt.currentTarget == xhr;
  }
  xhr.onerror = function(evt) {
    me.requestFail(this);
  }
  xhr.send(null);
  this.onStart();
};

AsyncRequest.prototype.restore = function(uri) {
  this.requestUrl = "http://migre.me/api_redirect.xml?url="+ encodeURIComponent(uri.spec);
  var xhr = this._createXhr();
  var me = this;
  xhr.onload = function(evt) {
    me.requestSuccess(this); // this == evt.target == evt.currentTarget == xhr;
  }
  xhr.onerror = function(evt) {
    me.requestFail(this);
  }
  xhr.send(null);
  this.onStart();
};


AsyncRequest.prototype._createXhr = function() {
  var item = Components
              .classes['@mozilla.org/extensions/manager;1']
              .getService(Components.interfaces.nsIExtensionManager)
              .getItemForID('migre.me@hultmann');
  var userAgent = item.name + '/' + item.version;


  var xhr = Components
              .classes['@mozilla.org/xmlextras/xmlhttprequest;1']
              .createInstance(Components.interfaces.nsIXMLHttpRequest);

  xhr.open("GET", this.requestUrl, true);
  xhr.setRequestHeader("Accept-Language", null);
  xhr.setRequestHeader("Cookie", null);
  xhr.setRequestHeader("Accept", "text/xml");
  xhr.setRequestHeader("User-Agent", userAgent);
  // LOAD_ONLY_IF_MODIFIED makes xhr results from cache be empty!
  //xhr.channel.loadFlags |= Components.interfaces.nsICachingChannel.LOAD_ONLY_IF_MODIFIED;
  return xhr;
};


AsyncRequest.prototype.requestFail = function(xhr) {
  this.onStop();
  var errorData = {
    id: 0,
    xhr: xhr,
    msg: null
  };
  this.onError(errorData, xhr);
};


AsyncRequest.prototype.requestSuccess = function(xhr) {
  this.onStop();
  var errorData = {
    id: 0,
    xhr: xhr,
    msg: null
  };

  if (xhr.status !== 200) {
    errorData.id = 1;
    this.onError(errorData);
    return;
  }

  var doc = xhr.responseXML;
  if (doc === null) {
    errorData.id = 2;
    this.onError(errorData);
    return;
  }


  if (doc.documentElement.namespaceURI === 'http://www.mozilla.org/newlayout/xml/parsererror.xml') {
    errorData.id = 3;
    this.onError(errorData);
    return;
  }


  var responseData = this.populateResponseData(doc);


  if (this.requestUrl.indexOf("http://migre.me/api_redirect.xml") === 0) {

    if (this.validateUncompressResponse(responseData, errorData)) {
      this.onSuccess(responseData.url);
    } else {
      this.onError(errorData);
    }

  } else {

    if (this.validateCompressResponse(responseData, errorData)) {
      this.onSuccess(responseData.migre);
    } else {
      this.onError(errorData);
    }
  }
};


AsyncRequest.prototype.validateCompressResponse = function(responseData, errorData) {
  if (responseData.error === null) {
    errorData.id = 4;
    return false;
  }
  if (responseData.error !== '0') {
    errorData.id = 5;
    errorData.msg = responseData.errormessage === null ? '' : responseData.errormessage;
    return false;
  }

  if (responseData.migre === null) {
    errorData.id = 4;
    return false;
  }

  return true;
};


AsyncRequest.prototype.validateUncompressResponse = function(responseData, errorData) {
  if (responseData.error === null) {
    errorData.id = 4;
    return false;
  }
  if (responseData.error !== '0') {
    errorData.id = 6;
    errorData.msg = responseData.errormessage === null ? '' : responseData.errormessage;
    return false;
  }

  if (responseData.url === null) {
    errorData.id = 4;
    return false;
  }

  return true;
};


AsyncRequest.prototype.populateResponseData = function(doc) {
  var rv = {
    error: null,
    errormessage: null,
    migre: null,
    url: null
  };

  var rvObj  = [      'error',       'errormessage',       'migre',       'url'];
  var xmlObj = ['/item/error', '/item/errormessage', '/item/migre', '/item/url'];


  var xmlValues = xmlObj.map(function(query) {
    var type = Components.interfaces.nsIDOMXPathResult.ANY_TYPE;
    return doc.evaluate(query, doc, null, type, null).iterateNext();
  });

  rvObj.forEach(function(val, idx) {
    if (xmlValues[idx] !== null) {
      rv[val] = xmlValues[idx].textContent;
    }
  });

  return rv;
};
